app/models/advert.py
from .base import BaseModel
from datetime import datetime
from sqlalchemy import Integer, String, Column, ForeignKey, Numeric, DateTime


class Advert(BaseModel):
    __tablename__ = "advert"
    id = Column(Integer, primary_key=True)
    name = Column(String(50), nullable=True)
    subcategory_id = Column(Integer, ForeignKey("subcategory.id"))
    user_id = Column(Integer, ForeignKey("user.id"))
    description = Column(String(2000), nullable=False)
    price = Column(Numeric, nullable=True)
    photos = Column(String(2000))
    location = Column(String(50), nullable=True)
    zip = Column(Integer, nullable=True)
    address = Column(String(50), nullable=True)
    published = Column(DateTime, default=datetime.utcnow())


    def __repr__(self):
        return f"<Advert {self.name} >"

app/models/base.py
from flask_migrate import Migrate
from flask_sqlalchemy import SQLAlchemy
from flask_sqlalchemy.model import DefaultMeta


db = SQLAlchemy()
migrate = Migrate()

BaseModel: DefaultMeta = db.Model

app/forms/login.py
from flask_wtf import FlaskForm
from wtforms import StringField, PasswordField, SubmitField, BooleanField
from wtforms.validators import DataRequired, Email



class LoginForm(FlaskForm):
    email = StringField("Email", validators=[DataRequired(), Email()],
        render_kw={
            "class": "form-control ",
            "placeholder": "Email or username",
            "type": "email",
            "autofocus": True,
            "id": "email"
            }
            )
    password = PasswordField("Password", validators=[DataRequired()],
        render_kw={
            "class": "form-control mt-1",
            "placeholder": "Password",
            "type": "password",
            "id": "password"
            }
    )
    remember = BooleanField("Remember me",
        render_kw={
            "type": "checkbox"
        }
    )
    submit = SubmitField("Sign in",
        render_kw={
            "class": "btn btn-lg btn-primary",
            "Type": "submit"
            }
    )

app/forms/signup.py
# pylint: disable=wrong-import-position, import-error
from pathlib import Path
import sys
projectdir = Path(__file__).parents[2]
sys.path.append(str(projectdir))
from app.models import User

from flask_wtf import FlaskForm
from wtforms import StringField, PasswordField, SubmitField
from wtforms.validators import DataRequired, Email, Regexp, EqualTo, ValidationError, Length, Optional


class SignupForm(FlaskForm):
    firstname = StringField("Firstname",
        validators=[
            Length(
                min=3,
                max=25,
                message="Firstname length must be between %(min)d and %(max)dcharacters"
                ),
            Optional()
            ],
        render_kw={
            "class": "form-control",
            "placeholder": "Enter firstname (optional)",
            "type": "text",
            "autofocus": True
            }
        )
    surename = StringField("Surename",
        validators=[
            Length(
                min=3,
                max=25,
                message="Surename length must be between %(min)d and %(max)dcharacters"
                ),
            Optional()
            ],
        render_kw={
            "class": "form-control mt-1",
            "placeholder": "Enter surename (optional)",
            "type": "text"
            }
        )
    email = StringField("Email",
        validators=[
            DataRequired(),
            Email(),
            Length(
                min=6,
                max=35,
                message="Email length must be between %(min)d and %(max)dcharacters"
                )
            ],
            render_kw={
                "class": "form-control mt-1",
                "placeholder": "Enter email",
                "type": "email",
                "id": "email"
                }
            )
    password = PasswordField("Password",
        # validators=[DataRequired(), Regexp(regexp)],
        validators=[
            DataRequired(),
            EqualTo("confirm", message="Passwords must match"),
            Length(
                min=8,
                max=35,
                message="Password length must be between %(min)d and %(max)dcharacters")
            ],
            render_kw={
                "class": "form-control mt-1",
                "placeholder": "Enter password",
                "type": "password"
                }
            )
    confirm = PasswordField("Repeat Password",
            render_kw={
                "class": "form-control mt-1",
                "placeholder": "Confirm password",
                "type": "password"
                }
    )
    # confirm = PasswordField("Confirm password",
    #     validators=[DataRequired(), Regexp(regexp), EqualTo("password_reg")],
    #         render_kw={
    #             "class": "form-control",
    #             "placeholder": "Enter password",
    #             "type": "password"
    #             }
    #         )
    submit = SubmitField("Sign Up",
        render_kw={
            "class": "btn btn-lg btn-primary",
            "Type": "submit"
            }
        )

    def validate_email(self, email):
        user = User.query.filter_by(email=email.data).first()
        if user:
            raise ValidationError("User with this email is already registered. Please use another one.")
        else:
            pass

app/views/advert.py
# pylint: disable=wrong-import-position, import-error
from pathlib import Path
import sys
projectdir = Path(__file__).parents[2]
sys.path.append(str(projectdir))
from app.models import Subcategory, Advert

from flask import abort, Blueprint, current_app, flash, redirect, render_template, request, url_for, send_from_directory
from flask_login import login_required, current_user
from jinja2 import TemplateNotFound


advert = Blueprint("advert", __name__, template_folder="templates", static_folder="static")

@advert.route('/pets/<int:ad_id>')
@login_required
def show(ad_id):
    content = Advert.query.get_or_404(ad_id)
    try:
        return render_template('advert.html', advert=content)
    except TemplateNotFound:
        abort(404)

app/views/home.py
# pylint: disable=wrong-import-position, import-error
from pathlib import Path
import sys
projectdir = Path(__file__).parents[2]
sys.path.append(str(projectdir))
from app.models import Advert

from flask import abort, Blueprint, current_app, flash, redirect, render_template, request, url_for, send_from_directory
from flask_login import login_required, current_user
from jinja2 import TemplateNotFound


home = Blueprint("home", __name__, template_folder="templates", static_folder="static")


@home.route("/")
@login_required
def root():
    return redirect(url_for("home.show"))

@home.route("/home", methods=["GET", "POST"])
@login_required
def show():
    ads = Advert.query.order_by(Advert.published.desc()).all()
    try:
        return render_template("home.html", name=current_user.firstname, email=current_user.email, ads=ads[:3])
    except TemplateNotFound:
        abort(404)

app/views/login.py
# pylint: disable=wrong-import-position, import-error
from pathlib import Path
import sys
projectdir = Path(__file__).parents[2]
sys.path.append(str(projectdir))
from app.forms import LoginForm
from app.models import User

from flask import abort, Blueprint, flash, redirect, render_template, url_for
from flask_login import login_user, current_user
from jinja2 import TemplateNotFound


login = Blueprint("login", __name__, template_folder="templates", static_folder="static")


@login.route("/login", methods=["GET", "POST"])
def show():
    if current_user.is_authenticated:
        flash("You are already logged in")
        return redirect(url_for("home.show"))

    form = LoginForm()
    try:
        return render_template("login.html", form=form)
    except TemplateNotFound:
        abort(404)


@login.route("/process-login", methods=["POST"])
def process():
    form = LoginForm()
    if form.validate_on_submit():
        user = User.query.filter_by(email=form.email.data).first()
        if user and user.check_password(form.password.data):
            login_user(user)
            flash("You are successfully authorized")
            return redirect(url_for("home.show"))

        flash("Wrong email or password")
        return redirect(url_for("login.show"))

app/views/logout.py
from flask import Blueprint, flash, redirect, url_for
from flask_login import logout_user


logout = Blueprint("logout", __name__, template_folder="templates", static_folder="static")


@logout.route("/logout")
def show():
    logout_user()
    flash("You are successfully logged out")
    return redirect(url_for("login.show"))

app/views/signup.py
# pylint: disable=wrong-import-position, import-error
from pathlib import Path
import sys
projectdir = Path(__file__).parents[2]
sys.path.append(str(projectdir))
from app.forms import SignupForm
from app.logger import logger
from app.models import User
from app.models.base import db

from flask import abort, Blueprint, current_app, flash, redirect, render_template, url_for
from flask_login import current_user
from jinja2 import TemplateNotFound
    

signup = Blueprint("signup", __name__, template_folder="templates", static_folder="static")


@signup.route("/signup")
def show():
    if current_user.is_authenticated:
        flash("You are already logged in")
        return redirect(url_for("home.show"))

    title = "Sign Up"
    form = SignupForm()
    try:
        return render_template(
            "signup.html",
            title=title,
            form=form,
            )
    except TemplateNotFound:
        abort(404)



@signup.route("/process-signup", methods=["POST"])
def process():
    form = SignupForm()
    if form.validate_on_submit():
        new_user = User(
            email=form.email.data,
            firstname=form.firstname.data,
            surename=form.surename.data
            )
        new_user.set_password(form.password.data)
        with current_app.app_context():
            db.session.add(new_user)            # pylint: disable=no-member
            db.session.commit()                 # pylint: disable=no-member

        flash("You are successfully signed up")
        return redirect(url_for("login.show"))

    # try:
    #     error = form.errors["email"][0]
    # except:
    #     try:
    #         error = form.errors["firstname"][0]
    #     except:
    #         password = form.password.data
    #         password_confirm = form.confirm.data
    #         if not password == password_confirm:
    #             flash("Пароли не совпадают. Повторите ввод")
    #             return redirect(url_for("registration"))
    #         error = "Пароль должен содержать хотя бы одну заглавную букву, хотя бы одну цифру и быть не менее 8 символов"

    # logger.info(error)
    # flash(error)
    return redirect(url_for("signup.show"))

app/views/upload.py
# pylint: disable=inconsistent-return-statements
from flask import abort, Blueprint, current_app, flash, redirect, render_template, request, url_for, send_from_directory
from jinja2 import TemplateNotFound
from os.path import join
from werkzeug.utils import secure_filename


upload = Blueprint("upload", __name__, template_folder="templates", static_folder="static")


def allowed_file(filename):
    return "." in filename and \
           filename.rsplit(".", 1)[1].lower() in current_app.config["ALLOWED_EXTENSIONS"]

@upload.route('/uploads/<name>')
def download_file(name):
    return send_from_directory(current_app.config["UPLOAD_FOLDER"], name)


@upload.route("/upload", methods=["GET", "POST"])
def upload_file():
    if request.method == "POST":
        # check if the post request has the file part
        if "file" not in request.files:
            flash("No file part")
            return redirect(request.url)
        file = request.files["file"]
        # If the user does not select a file, the browser submits an
        # empty file without a filename.
        if file.filename == "":
            flash("No selected file")
            return redirect(request.url)
        if file and allowed_file(file.filename):
            filename = secure_filename(file.filename)
            # Здесь надо класть filename в базу
            file.save(join(current_app.config["UPLOAD_FOLDER"], filename))
            return redirect(url_for("download_file", name=filename))
    try:
        return render_template("upload.html")
    except TemplateNotFound:
        abort(404)

app/templates/advert.html
{% extends 'base.html' %}

{% block title %}
Advert
{% endblock %}

{% block body %}
<div class="container mt-4 mb-4 slider w-25 h-25">
    <div id="carouselExampleControls" class="carousel slide" data-bs-ride="carousel">
        <div class="carousel-inner">
            <div class="carousel-item active">
                <img src="https://upload.wikimedia.org/wikipedia/commons/thumb/0/0c/American_Shorthair.jpg/640px-American_Shorthair.jpg" class="d-block w-100" alt="...">
            </div>
            <div class="carousel-item">
                <img src="https://upload.wikimedia.org/wikipedia/commons/thumb/0/0e/Hyacintduiven_01.jpg/640px-Hyacintduiven_01.jpg" class="d-block w-100" alt="...">
            </div>
            <div class="carousel-item">
                <img src="https://upload.wikimedia.org/wikipedia/commons/thumb/b/b2/Sheffiled-red.jpg/320px-Sheffiled-red.jpg" class="d-block w-100" alt="...">
            </div>
        </div>
        <button class="carousel-control-prev" type="button" data-bs-target="#carouselExampleControls" data-bs-slide="prev">
            <span class="carousel-control-prev-icon" aria-hidden="true"></span>
            <span class="visually-hidden">Previous</span>
        </button>
        <button class="carousel-control-next" type="button" data-bs-target="#carouselExampleControls" data-bs-slide="next">
            <span class="carousel-control-next-icon" aria-hidden="true"></span>
            <span class="visually-hidden">Next</span>
        </button>
    </div>
</div>


{% endblock %}

app/templates/base.html
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>My Ad World | {% block title %}{% endblock %}</title>
    {% block styles %}
    <!-- Bootstrap CSS -->
    {{ bootstrap.load_css() }}
    <!-- Main CSS-->
    <link rel="stylesheet" type="text/css" href="static/css/main.css">
    {% endblock %}
</head>

<body>
    {% for category, message in get_flashed_messages(with_categories=True) %}
        {% if category == "message" %}
        <div class="alert alert-success text-center">{{ message }}</div>
        {% else %}
        <div class="alert alert-danger text-center">{{ message }}</div>
        {% endif %}
    {% endfor %}


    {% block body %}
    {% endblock %}

    
    {% block script %}
        <!-- Bootstrap JavaScript -->
        {{ bootstrap.load_js() }}
    {% endblock %}

    {% block footer %}
    {% endblock %}
</body>

</html>

app/templates/home.html
{% extends 'base.html' %}

{% block title %}
Home
{% endblock %}

{% block body %}

<!-- Navbar --> 
<nav class="navbar navbar-light bg-light border-bottom">
    <div class="container-fluid">
        <a class="navbar-brand px-4" href="#">
            <img src="https://getbootstrap.com/docs/5.0/assets/brand/bootstrap-logo.svg"" alt="" width="30" height="24"
                class="d-inline-block align-text-top">
            My Ad World
        </a>
        <div class="position-relative px-4">
            <a href="#" class="btn btn-primary btn rounded-pill" role="button" aria-pressed="true">My Profile</a>
            <a href="{{ url_for('logout.show') }}" class="btn btn-primary btn rounded-pill" role="button" aria-pressed="true">Logout</a>
        </div>
    </div>
</nav>

<!-- Search bar -->
<div class="container">
    <form class="d-flex justify-content-center mt-4 form-control-lg">
        <input class="form-control me-1 w-25" type="search" placeholder="Search" aria-label="Search">
        <button type="button" class="btn btn-primary rounded-circle">
            <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-search"
                viewBox="0 0 16 16">
                <path
                    d="M11.742 10.344a6.5 6.5 0 1 0-1.397 1.398h-.001c.03.04.062.078.098.115l3.85 3.85a1 1 0 0 0 1.415-1.414l-3.85-3.85a1.007 1.007 0 0 0-.115-.1zM12 6.5a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0z">
                </path>
            </svg>
        </button>
    </form>
</div>

<!-- New ads -->
<h4 class="text-center font-weight-normal h4 mt-4">
    Top ads
</h4>
<div class="container mt-4">
    <div class="row">
        {% for ad in ads %}
        <div class="col-md-4">
            <div class="card">
                {% set photos = ad.photos.split(',') %}
                {% set photo = photos[0] | replace('"','') | replace('[','') %}
                <div class="ratio ratio-1x1">
                    <img src="{{ photo }}"  alt="Card Image">
                </div>
                <div class="card-body">
                    <small class="text-muted">{{ ad.zip }} {{ ad.location }}</small>
                    <h5 class="card-title mt-1">{{ ad.name }}</h5>
                    <!-- <p class="card-text">{{ ad.description[:100] }}...</p> -->
                    <p><small class="text-muted mt-1">{{ ad.price }},-€</small></p>
                    <a href="{{ url_for('advert.show', ad_id=ad.id) }}" class="btn btn-primary mb-3 rounded-pill">Go to advert</a>
                </div>
            </div>
        </div>
        {% endfor %}
    </div>
</div>


{% endblock %}s

{% block script %}
<script src="/static/js/main.js"></script>
{% endblock %}

{% block footer %}
{% endblock %}

app/templates/login.html
{% extends 'base.html' %}

{% block title %}
Sign in
{% endblock %}

{% block body %}
<div class="text-center mt-5">
    <form style="max-width:480px;margin:auto;" action="{{ url_for('login.process') }}" method="post">
        {{ form.csrf_token() }}
        <img class="mt-4 mb-4" src="https://getbootstrap.com/docs/5.0/assets/brand/bootstrap-logo.svg"
            alt="Bootstrap Logo" height="72">
        <h1 class="h3 mb-3 font-weight-normal">Please sign in</h1>
        {{ form.email() }}
        {{ form.password() }}
        <div class="checkbox mt-3">
            {{ form.remember() }}
            {{ form.remember.label }}
            <a href="#!" class="px-2">Forgot password?</a>
        </div>
        <div class="mt-3 d-grid gap-2">
            {{ form.submit() }}
        </div>
        <p class="mt-3">
            Do not have an account yet? <a href="{{ url_for('signup.show') }}">Create a new account</a>
        </p>
    </form>

</div>

{% endblock %}

{% block footer %}
<footer>
    <!-- Copyright -->
    <div class="position-absolute bottom-0 start-50 translate-middle-x mb-5">
        © 2022 Copyright
    </div>
    <!-- Copyright -->
</footer>
{% endblock %}

app/templates/signup.html
{% extends 'base.html' %}

{% block title %}
Sign Up
{% endblock %}

{% block body %}
<div class="text-center mt-5">
    {% for field, errors in form.errors.items() %}
    {{ ', '.join(errors) }}
    {% endfor %}
    <form style="max-width:480px;margin:auto;" action="{{ url_for('signup.process') }}" method="post">
        {{ form.csrf_token() }}
        <img class="mt-4 mb-4" src="https://getbootstrap.com/docs/5.0/assets/brand/bootstrap-logo.svg"
            alt="Bootstrap Logo" height="72">
        <h1 class="h3 mb-3 font-weight-normal">Registration form</h1>
        {{ form.firstname() }}
        {{ form.surename() }}
        {{ form.email() }}
        {{ form.password() }}
        {{ form.confirm() }}
        <div class="mt-3 d-grid gap-2">
            {{ form.submit() }}
        </div>
    </form>
    <ul class="pagination mt-3 justify-content-center">
        <li class="page-item"><a class="page-link" href="{{ url_for('login.show') }}">to sign in</a></li>
    </ul>
</div>
{% endblock %}

{% block footer %}
<footer>
    <!-- Copyright -->
    <div class="position-absolute bottom-0 start-50 translate-middle-x mb-5">
        © 2022 Copyright
    </div>
    <!-- Copyright -->
</footer>
{% endblock %}

app/templates/upload.html
{% extends 'base.html' %}

{% block title %}
Upload new File
{% endblock %}

{% block body %}
<h1>Upload new File</h1>
<form method=post enctype=multipart/form-data>
    <input type=file name=file>
    <input type=submit value=Upload>
</form>
{% endblock %}